#ifndef MSP_HTTP_UTILS_H_
#define MSP_HTTP_UTILS_H_

#include <map>
#include <string>

namespace Msp {
namespace Http {

enum EncodeLevel
{
	MINIMAL,
	SAFE,
	PARANOID
};

struct Url
{
	std::string scheme;
	std::string host;
	std::string path;
	std::string query;
	std::string fragment;
};

typedef std::map<std::string, std::string> Query;

std::string urlencode(const std::string &, EncodeLevel =SAFE);
std::string urlencode_plus(const std::string &, EncodeLevel =SAFE);
std::string urldecode(const std::string &);
Url parse_url(const std::string &);
std::string build_url(const Url &);
Query parse_query(const std::string &);
std::string build_query(const Query &);

} // namespace Http
} // namespace Msp

#endif
